﻿import { ITableRow } from "../../Core/ITableRow";
import { TableBase } from "../../Core/TableBase";
import { TableManager } from "../../TableManager";

/**
 * 共用_字串表#string.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class StringTableExample extends TableBase<StringExampleTableRow> {
	private _stringFilter: StringFilterTable;

	/**  共用_字串表#string.xlsx > #string_filter */
	public get StringFilter(): StringFilterTable {
		return this._stringFilter = this._stringFilter || TableManager.InitTable("#string#string_filter", StringFilterTable, StringFilterTableRow);
	}
}

/**
 * #string
 */
export class StringExampleTable extends TableBase<StringExampleTableRow> {
}

export class StringExampleTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
	/** 越南文讯息 */
	MsgVi: string;
	/** 泰文讯息 */
	MsgTh: string;
}

/**
 * #string_filter
 */
export class StringFilterTable extends TableBase<StringFilterTableRow> {
}

export class StringFilterTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 過濾字串 */
	FilterWord: string;
}
