import { NetRequestSD } from "@/Engine/CatanEngine/NetManagerV2/NetRequestSD";
import { LanguageManager } from "@/FormTableExt/Manage/Language/LanguageManager";
import { NetRequest } from "../../Engine/CatanEngine/NetManagerV2/NetRequest";

//=======================================================================================
/**取得歷史紀錄網頁網址協定 */
export class HistoryRequest extends NetRequest<any, JSON> {
	get Method(): string {
		return "history.url";
	}

	constructor(slotId: number) {
		super();
		this.Data = {
			slot: slotId,
			lang: LanguageManager.UseLanguageUrlStr,
		};
	}
}
//=======================================================================================
export class SlotInRequest extends NetRequestSD<any, JSON> {
	get Method(): string {
		return "slot.in";
	}
	constructor(slotid: number, hall: number = 0, uid: number = 0) {
		super();
		this.Data = {
			id: slotid
		};
	}
}
//=======================================================================================
export class SlotOutRequest extends NetRequest<null, null> {
	get Method(): string {
		return "slot.out";
	}
}
//=======================================================================================
export class FishOutRequest extends NetRequest<null, null> {
	get Method(): string {
		return "fish.out";
	}
}
//=======================================================================================
export class TableOutRequest extends NetRequest<null, null> {
	get Method(): string {
		return "table.out";
	}
}
//=======================================================================================
export class Table3002OutRequest extends NetRequest<any, JSON> {
	get Method(): string {
		return "two_sicbo.leave";
	}
	constructor() {
		super();
	}
}
//=======================================================================================
export class Table3003OutRequest extends NetRequest<any, JSON> {
	get Method(): string {
		return "nine_sicbo.leave";
	}
	constructor() {
		super();
	}
}
//=======================================================================================
export class Table3012OutRequest extends NetRequest<any, JSON> {
	get Method(): string {
		return "triple_baccarat.leave";
	}
	constructor() {
		super();
	}
}
//=======================================================================================
export class PinBallOutRequest extends NetRequest<null, null> {
	get Method(): string {
		return "pinball.out";
	}
}
//=======================================================================================
